#pragma once

#include "v3.h"
#include "M3x3.h"
#include "framebuffer.h"
#include "phc.h"

class TMesh {

  V3 *vertices, *projVertices;
  int verticesN;
  V3 *colors;
  float *tcs;
  V3 *normals;
  unsigned int *connectivity;
  int trianglesN;
public:
  FrameBuffer *texture;
  TMesh();
  TMesh(V3 center, float dims[2]); // makes a quad parallel to z plane
  void Load(char *fname);
  void RenderPoints(PPC *ppc, FrameBuffer *fb);
  V3 GetCenter();
  void Translate(V3 trans);
  void Scale(float scf);
  BBox ComputeBBox();
  void PlaceAndScale(V3 newCenter, float bboxDiag);
  void Render(PPC *ppc, FrameBuffer *fb, PPC *projPPC, FrameBuffer *projFB);
  M3x3 ComputeBarycentricInverse(V3 pvs[3]);
  M3x3 ComputeSSI(V3 pvs[3]);
  void Project(PPC *ppc);
  void SetColors(V3 *cols);
  void SetTCsQuad();
  M3x3 ComputeMMI(unsigned int inds[3], PPC *ppc);
  V3 GetNumABC(M3x3 qM, V3 rv);
  void RenderHW();
};